/* 
 * File:   spurious.c
 * Author: Carlo Alessandro Nicolau @ INFN
 * 
 * Firmware for BPD board.
 * Functions that could (and thus should) be auto-generated but would require a big refactoring of python code.
 * 
 */

#include "spurious.h"
#include "errors.h"
#include "generated/sources/variables.h"
#include "mcc_generated_files/mcc.h"

bool* alarm_get_enable_ptr_by_enum(enum_alarm_number_t _alarm_index) {
    if(alarm_is_analog_by_enum(_alarm_index)) {
        return &(alarm_get_analog_alarm_ptr_by_enum(_alarm_index)->enabled);
    }else{
        return &(alarm_get_digital_alarm_ptr_by_enum(_alarm_index)->enabled);        
    }    
}

alarm_timeout_t* alarm_get_timeout_ptr_by_enum(enum_alarm_number_t _alarm_index) {
    if(alarm_is_analog_by_enum(_alarm_index)) {
        return &(alarm_get_analog_alarm_ptr_by_enum(_alarm_index)->timeout);
    }else{
        return &(alarm_get_digital_alarm_ptr_by_enum(_alarm_index)->timeout);        
    }        
}

alarm_timeout_t* alarm_get_timeout_counter_max_ptr_by_enum(enum_alarm_number_t _alarm_index) {
    if(alarm_is_analog_by_enum(_alarm_index)) {
        return &(alarm_get_analog_alarm_ptr_by_enum(_alarm_index)->timeout_counter_max);
    }else{
        return &(alarm_get_digital_alarm_ptr_by_enum(_alarm_index)->timeout_counter_max);        
    }        
}

alarm_firecount_t* alarm_get_firecount_ptr_by_enum(enum_alarm_number_t _alarm_index) {
    if(alarm_is_analog_by_enum(_alarm_index)) {
        return &(alarm_get_analog_alarm_ptr_by_enum(_alarm_index)->firecount);
    }else{
        return &(alarm_get_digital_alarm_ptr_by_enum(_alarm_index)->firecount);        
    }        
}

// ...see .h
void switch_SWITCH_VEOC_RETURN_set_open_fromIRQ(void) {
    DOUT_375V_RTN_SWITCH_ON_OFF_SetLow();
    switches.state_SWITCH_VEOC_RETURN = SWITCHSTATE_OPEN;
}

// ...see .h
void switch_SWITCH_VEOC_DIRECT_set_open_fromIRQ(void) {    
    DOUT_375V_FWR_SWTCH_ON_OFF_SetLow();
    switches.state_SWITCH_VEOC_DIRECT = SWITCHSTATE_OPEN;
}

// ...see .h
void switch_SWITCH_HYDRO_set_open_fromIRQ(void) {
    DOUT_HYDRO_SWITCH_ON_OFF_SetLow();
    switches.state_SWITCH_HYDRO = SWITCHSTATE_OPEN;
}

// ...see .h
void switch_SWITCH_LBL_set_open_fromIRQ(void) {
    DOUT_LBL_SWITCH_ON_OFF_SetLow();
    switches.state_SWITCH_LBL = SWITCHSTATE_OPEN;
}

void dummy_alarm_callback(void) {
    // should never be called
    error_die_forever_fromIRQ();
}
