/* 
 * File:   spurious.h
 * Author: Carlo Alessandro Nicolau @ INFN
 * 
 * Firmware for BPD board.
 * Functions that could (and thus should) be auto-generated but would require a big refactoring of python code.
 * 
 */

#ifndef __SPURIOUS_H
#define	__SPURIOUS_H

#include "typedefs.h"
#include "generated/sources/variables.h"

bool* alarm_get_enable_ptr_by_enum(enum_alarm_number_t _alarm_index);
alarm_timeout_t* alarm_get_timeout_ptr_by_enum(enum_alarm_number_t _alarm_index);
//alarm_timeout_t* alarm_get_timeout_counter_ptr_by_enum(enum_alarm_number_t _alarm_index);
alarm_timeout_t* alarm_get_timeout_counter_max_ptr_by_enum(enum_alarm_number_t _alarm_index);
alarm_firecount_t* alarm_get_firecount_ptr_by_enum(enum_alarm_number_t _alarm_index);

// Switch control functions (to be called from IRQ)
// they are just replicated versions of non-IRQ, to avoid compiler complaining:
// "appears in multiple call graphs and has been duplicated by the compiler"
void switch_SWITCH_VEOC_RETURN_set_open_fromIRQ(void);
void switch_SWITCH_VEOC_DIRECT_set_open_fromIRQ(void);
void switch_SWITCH_HYDRO_set_open_fromIRQ(void);
void switch_SWITCH_LBL_set_open_fromIRQ(void);

void dummy_alarm_callback(void);

#endif // __SPURIOUS_H

